routes/web.php
<?php

use App\Http\Controllers\AuthorController;
use App\Http\Controllers\BlogPostController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\InternalAreaController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
     // return view('welcome');
     // return "GIPE 2022 - Let's start the endeavour and create a portal for the Colegio San Juan Apostol in Arequipa, Peru!";
     // return view('home.index',[]);
// })->name('home.index');
// Route::get('/contact', function () {
    // return "This is the contact page!";
    // return view('home.contact',[]);
// })->name('contact.index');
Route::get('/', [HomeController::class,'home'])->name('home.index');
Route::get('/contact', [HomeController::class,'contact'])->name('contact.index');
// $posts = [
//     1 => [
//         'title' => 'Intro to laravel',
//         'content' => 'This is a short intro to laravel',
//         'is_new' => true
//     ],
//     2 => [
//         'title' => 'Intro to PHP',
//         'content' => 'This is a short intro to PHP',
//         'is_new' => false
//     ],
// ];
// Route::get('/posts', function () use ($posts) {
//     // return "This is the posts page!";
//     return view('posts.index',['posts' => $posts]);
// })->name('posts.index');
// Route::get('/posts/{id}', function ($id) use ($posts) {
//     // return "Blog Post {$id}";
//     abort_if(!isset($posts[$id]), 404);
//     return view('posts.show', ['post' => $posts[$id]]);
// })->name('posts.show');
Route::get('/recent-posts/{days_ago?}', function ($days_ago = 20) {
    return "Posts from {$days_ago} days ago";
})->name('posts.recent.index');
Route::resource('blogposts',BlogPostController::class);
Route::resource('authors',AuthorController::class);
Route::resource('comments',CommentController::class)->only(['store','create']);
Route::get('/home', [InternalAreaController::class, 'home'])->name('home.index');
Auth::routes();

resources/views/posts/create.blade.php
@extends('layout.app')
@section('title', 'Blog posts page')
@section('content')
    <h1>Create a new Blog Post</h1>
    <div class="mx-auto">
        <form action={{ route('blogposts.store') }} method="POST" enctype="multipart/form-data">
            @csrf
            @include('posts.partials.form')
            <button type="submit" class="btn btn-primary">Create</button>
        </form>
    </div>
@endsection

resources/views/posts/index.blade.php
@extends('layout.app')
@section('title', 'Blog posts page')
@section('content')
    <h1>Our Blog Posts</h1>
    <table class="table table-stripped">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Title</th>
                <th scope="col">Content</th>
                <th scope="col">Written by</th>
                <th scope="col">Highlight</th>
                <th scope="col">All Comments</th>
                <th scope="col">New Comments</th>
                <th scope="col" colspan="2">
                    @if (auth()->user() != null &&
                        auth()->user()->hasRole(['Admin', 'Super-Admin']))
                        Actions
                    @endif
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach ($posts as $key => $post)
                <tr>
                    <th scope="row">{{ $key + 1 }}</th>
                    <td>{{ $post['blogPostTitle'] }}</td>
                    <td>{{ $post['blogPostContent'] }}</td>
                    <td>{{ $post->user['name'] }}</td>
                    <td>{{ $post['blogPostIsHighlight'] == 1 ? 'YES' : 'NO' }}</td>
                    <td>{{ $post['comments_count'] }}</td>
                    <td>{{ $post['new_comments'] }}</td>
                    <td>
                        <form action="{{ route('blogposts.show', ['blogpost' => $post->id]) }}" method="GET">
                            <x-button class="primary" text="Show" />
                        </form>
                    </td>
                    <td>
                        @can('edit Blog posts')
                            <form action="{{ route('blogposts.edit', ['blogpost' => $post->id]) }}" method="GET">
                                <x-button class="info" text="Edit" />
                            </form>
                        @endcan
                    </td>
                    <td>
                        @if (auth()->user() != null &&
                            auth()->user()->hasRole('Super-Admin'))
                            <form action="{{ route('blogposts.destroy', ['blogpost' => $post->id]) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <x-button text="Delete" class="danger" />
                            </form>
                        @endif
                    </td>
                </tr>
            @endforeach
        </tbody>
    </table>
@endsection

resources/views/posts/show.blade.php
@extends('layout.app')
@section('title', 'Blog posts page')
@section('content')
    {{-- @if ($post['is_new'])
    <div>This is a new blog post</div>
        @elseif(!$post['is_new'])
        <div>This is an old blog post</div>
    @endif --}}
    <div>
        @if ($post['blogPostIsHighLight'])
            This is a highlited Blog Post!
        @elseif(!$post['blogPostIsHightlight'])
            This is not a highlighted Blog Post!
        @endif
    </div>
    <div class="d-flex flex-column align-items-center justify-content">
        @if ($post->image)
            <div class="bg-light">
                <img src="{{ $post->image->url() }}" alt="Blog Post Image" class="w-50 p-3">
                <h1>{{ $post['blogPostTitle'] }}</h1>
            </div>
            <p>{{ $post['blogPostContent'] }}</p>
        @else
            <h1>This Blog Post does not have an image!</h1>
            <h2>{{ $post['blogPostTitle'] }}</h2>
            <p>{{ $post['blogPostContent'] }}</p>
        @endif
        <div class="bg-secondary mw-100">
            {{-- This Blog Post has {{ $post['comments_count'] }} comments! --}}
            <h3>{{ __('blogPostComments') }} {{ trans_choice('numberOfBlogPostComments', $post['comments_count']) }}
            </h3>
        </div>
    </div>
@endsection

resources/views/posts/update.blade.php
@extends('layout.app')
@section('title', 'Update a blog')
@section('content')
    <h1>Update an existing Blog</h1>
    <div class="mx-auto">
        <form action={{ route('blogposts.update',['blogpost'=>$post->id]) }} method="POST" enctype="multipart/form-data">
            @csrf
            @method('PUT')
            @include('posts.partials.form')
            <button type="submit" class="btn btn-primary">Update</button>
        </form>
    </div>
@endsection